
DROP TABLE nightmare;
CREATE TABLE nightmare (id bigint, ts timestamp not null default now(), stext text not null, ltext text, lob oid) PARTITION BY HASH (id);
CREATE TABLE nightmare_p0 PARTITION OF nightmare FOR VALUES WITH (modulus 2, remainder 0);
CREATE TABLE nightmare_p1 PARTITION OF nightmare FOR VALUES WITH (modulus 2, remainder 1);

CREATE OR REPLACE FUNCTION random_string( int ) RETURNS TEXT as $$
	SELECT string_agg(substring('0123456789bcdfghjkmnpqrstvwxyz', round(random() * 30)::integer, 1), '') FROM generate_series(1, $1);
$$ LANGUAGE sql;

INSERT INTO nightmare(id, stext, ltext, lob) SELECT 
	n, 
	random_string(10),
	random_string(3000),
	lo_import('/etc/passwd')
FROM generate_series(1,10000) AS n;

-- produce 2 larger entries
INSERT INTO nightmare (id, stext, ltext, lob) SELECT 
	n, 
	random_string(10),
	random_string(300000),	
 	lo_import('/bin/bash')
FROM generate_series(10001, 10002) AS n;

ALTER TABLE nightmare ADD PRIMARY KEY (id);
CREATE INDEX nightmare_brin_idx ON nightmare USING BRIN(ts);

ANALYZE nightmare, nightmare_p0, nightmare_p1;

-- read table to avoid hint bits preventing incremental backups from working
SELECT count(*), sum(length(stext)) FROM nightmare;


