#!/bin/bash

. testlib.sh

initprimary 15432 /var/lib/postgresql/17/main fulldbbackup

psql -p 15432 -c "vacuum full;" # get some more WAL

echo "wal_level=minimal" > /var/lib/postgresql/17/main/postgresql.auto.conf
echo "max_wal_senders=0" >> /var/lib/postgresql/17/main/postgresql.auto.conf
pg_ctl -D /var/lib/postgresql/17/main -l logfile stop
pg_ctl -D /var/lib/postgresql/17/main -l logfile start
sleep 1

# does not cover partitions(!)
#psql -p 15432 -c "create table t2 (like nightmare including all);" # on wal_level=minimal opt
psql -p 15432 -c "create table t2 as select * from nightmare;" # on wal_level=minimal opt
psql -p 15432 -c "drop table nightmare;" 
psql -p 15432 -c "alter table t2 rename to nightmare;"
psql -p 15432 -c "reindex database;" # wal_level=minimal opt

#incr backup not possible here due to:
# FATAL:  number of requested standby connections exceeds max_wal_senders (currently 0)

echo "wal_level=replica" > /var/lib/postgresql/17/main/postgresql.auto.conf
pg_ctl -D /var/lib/postgresql/17/main -l logfile stop
pg_ctl -D /var/lib/postgresql/17/main -l logfile start
sleep 1

psql -p 15432 -c "select pg_create_restore_point('restorepoint1');"
pg_basebackup -c fast -D incr1 -p 15432 --incremental fulldbbackup/backup_manifest
psql -p 15432 -c "truncate nightmare;"

pitr 15432 /var/lib/postgresql/17/main "fulldbbackup incr1" restorepoint1
checkrestoreworked 15432

