#!/bin/bash

. testlib.sh

initprimary 15432 /var/lib/postgresql/17/main fulldbbackup

psql -p 15432 -c "create database d1;"
pg_basebackup -c fast -D incr1 -p 15432 --incremental fulldbbackup/backup_manifest

psql -p 15432 -c "create database d2;"
pg_basebackup -c fast -D incr2 -p 15432 --incremental incr1/backup_manifest

psql -p 15432 -c "create database d3;"
psql -p 15432 -c "select pg_create_restore_point('restorepoint1');"
pg_basebackup -c fast -D incr3 -p 15432 --incremental incr2/backup_manifest
psql -p 15432 -c "drop database d1;"
psql -p 15432 -c "drop database d2;"
psql -p 15432 -c "drop database d3;"

pitr 15432 /var/lib/postgresql/17/main "fulldbbackup incr1 incr2 incr3" restorepoint1
psql -p 15432 -d d1 -c "select 'ok'" || echo fail
psql -p 15432 -d d2 -c "select 'ok'" || echo fail
psql -p 15432 -d d3 -c "select 'ok'" || echo fail
checkrestoreworked 15432

