#!/bin/bash

. testlib.sh

initprimary 15432 /var/lib/postgresql/17/main fulldbbackup

# test unlogged table forks
psql -p 15432 -c "create unlogged table t2 as select * from nightmare;" # on wal_level=minimal opt
psql -p 15432 -c "drop table nightmare;"
psql -p 15432 -c "alter table t2 rename to nightmare;"
psql -p 15432 -c "\\dt+"
psql -p 15432 -c "alter table nightmare set logged;" #rewrite
psql -p 15432 -c "\\dt+"
psql -p 15432 -c "select pg_create_restore_point('restorepoint1');"
pg_basebackup -c fast -D incr1 -p 15432 --incremental fulldbbackup/backup_manifest

psql -p 15432 -c "select pg_switch_wal();"
rm -rf /tmp/pg_wal
cp -r /var/lib/postgresql/17/main/pg_wal /tmp

# this will shutdown normally , so data should be there
pitr 15432 /var/lib/postgresql/17/main "fulldbbackup incr1" restorepoint1 
checkrestoreworked 15432

