#!/bin/bash

# args: port, dir, fullbackupname
function initprimary() {

	pg_ctl -D $2 -l logfile stop > /dev/null 2>&1
	rm -rf $2
	rm -rf fulldbbackup* incr? # backups
	rm -f /tmp/before /tmp/after # check output files
	cp /dev/null logfile

#		-c "log_min_messages=DEBUG5" \
	initdb --data-checksums -D $2 -c "port=$1" \
		-c "max_wal_size=40MB" \
		-c "min_wal_size=40MB" \
		-c "max_prepared_transactions=100" # > /dev/null 2>&1
	pg_ctl -D $2 -l logfile start
	sleep 1
	
	psql -p $1 -f init.sql
	pg_basebackup -c fast -D $3 -p $1
	psql -p $1 -c "delete from nightmare where id in (1, 10, 100, 1000);"
	psql -p $1 -f vrfy.sql | tee -a /tmp/before
}

# args: port, dir, "backup list", restorepoint 
function pitr() {
	pg_ctl -D $2 -l logfile stop
	rm -rf $2
	pg_combinebackup -o $2 $3
	echo "recovery_target_name='$4'" > $2/postgresql.auto.conf
	if [[ "$5" != "" ]]; then
		echo "Restoring WAL"
		cp $5/* $2/pg_wal/
	fi
	pg_ctl -D $2 -l logfile start
}


# args: port
function checkrestoreworked() {
	sleep 1
	psql -p $1 -f vrfy.sql | tee -a /tmp/after
	diff -u /tmp/before /tmp/after
	if [ $? -eq 0 ]; then
        	echo "ALL OK"
        	exit 0
	else
		echo "FAILURE!"
		exit 100
	fi
}

